<?php
namespace Incoviba\Repository\Persona;

use Incoviba\Common\Define;
use Incoviba\Common\Ideal;
use Incoviba\Common\Implement;
use Incoviba\Model;
use Incoviba\Repository\Direccion;
use Incoviba\Repository\Persona;

class Datos extends Ideal\Repository
{
    public function __construct(Define\Connection $connection, protected Persona $personaRepository,
                                protected Direccion $direccionRepository)
    {
        parent::__construct($connection);
        $this->setTable('datos_personas');
    }

    public function create(?array $data = null): Model\Persona\Datos
    {
        $map = (new Implement\Repository\MapperParser())
            ->register('persona_rut', (new Implement\Repository\Mapper())
                ->setProperty('persona')
                ->setFunction(function($data) {
                    return $this->personaRepository->fetchById($data['persona_rut']);
                }))
            ->register('direccion_id', (new Implement\Repository\Mapper())
                ->setProperty('direccion')
                ->setFunction(function($data) {
                    return $this->direccionRepository->fetchById($data['direccion_id']);
                })->setDefault(null))
            ->register('telefono', (new Implement\Repository\Mapper())->setFunction(function($data) {
                    return $data['telefono'];
                })->setDefault(null))
            ->register('email', (new Implement\Repository\Mapper())->setFunction(function($data) {
                    return $data['email'];
                })->setDefault(null))
            ->register('fecha_nacimiento', (new Implement\Repository\Mapper\DateTime('fecha_nacimiento'))
                ->setDefault(null)
                ->setProperty('fechaNacimiento'))
                ->register('sexo', (new Implement\Repository\Mapper())->setFunction(function($data) {
                    return $data['sexo'];
                })->setDefault(null))
            ->register('estado_civil', (new Implement\Repository\Mapper())->setFunction(function($data) {
                    return $data['estado_civil'];
                })->setDefault(null)->setProperty('estadoCivil'))
            ->register('nacionalidad', (new Implement\Repository\Mapper())->setFunction(function($data) {
                    return $data['nacionalidad'];
                })->setDefault(null))
            ->register('ocupacion', (new Implement\Repository\Mapper())->setFunction(function($data) {
                    return $data['ocupacion'];
                })->setDefault(null));
        return $this->parseData(new Model\Persona\Datos(), $data, $map);
    }
    public function save(Define\Model $model): Model\Persona\Datos
    {
        $this->saveNew([
            'persona_rut', 'direccion_id', 'telefono', 'email', 'fecha_nacimiento', 'sexo', 'estado_civil',
            'nacionalidad', 'ocupacion'
        ], [
            $model->persona->rut, $model->direccion?->id, $model->telefono, $model->email, $model->fechaNacimiento,
            $model->sexo, $model->estadoCivil, $model->nacionalidad, $model->ocupacion
        ]);
        return $model;
    }
    public function edit(Define\Model $model, array $new_data): Model\Persona\Datos
    {
        return $this->update($model, [
            'direccion_id', 'telefono', 'email', 'fecha_nacimiento', 'sexo', 'estado_civil',
            'nacionalidad', 'ocupacion'
        ], $new_data);
    }

    /**
     * @param int $persona_rut
     * @return Model\Persona\Datos
     * @throws Implement\Exception\EmptyResult
     */
    public function fetchByPersona(int $persona_rut): Model\Persona\Datos
    {
        $query = $this->connection->getQueryBuilder()
            ->select()
            ->from($this->getTable())
            ->where('persona_rut = ?');
        return $this->fetchOne($query, [$persona_rut]);
    }
}
